/*


    Evolute version 0.7
    Copyright (C) 2010 Antti Vainio

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/

//          newgame.cpp

#include <math.h>
#include "global.hpp"

//karttavalikko
void newgame(float kasautuminen) {
     bool pois1 = false; //aloita poistuminen
     bool pois2 = false; //ulos loopista!
     short int valinta = 0;
     short int prewvalinta = 0;
     
     asetakartta("");
     
     while(!pois2) {
                 alkuaika = SDL_GetTicks();
                 
                 //hiiri ja nappulat
                 SDL_GetMouseState(&hiirix,&hiiriy);
                 pelaajaninputit = SDL_GetKeyState(NULL);
                 if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1)) hiiriekanappi = true;
                 else hiiriekanappi = false;
                 
                 //lasketaan kasautuminen
                 if(!pois1) kasautuminen++;
                 else if(menuvalinta != 100) kasautuminen--;
                 else kasautuminen-= 0.25;
                 if(pois1 && menuvalinta != 100 && kasautuminen < 1) pois2 = true;
                 if(pois1 && menuvalinta == 100 && kasautuminen < 0.25) pois2 = true;
                 if(kasautuminen < 20) SDL_SetAlpha(valkoinenfade, SDL_SRCALPHA, int(round(255 - kasautuminen * 12.75)));
                 else SDL_SetAlpha(valkoinenfade, SDL_SRCALPHA, 0);
                 
                 //testataan onko hiiri nappien päällä
                 if(kasautuminen > 20 && hiirix > 250 && hiirix < 550) {
                           if(hiiriy > 145 && hiiriy < 205) {
                                     valinta = 100; //suoraan peliin
                                     asetakartta("Tutorial");
                           }
                           else if(hiiriy > 245 && hiiriy < 305) valinta = 10;
                           else if(hiiriy > 345 && hiiriy < 405) valinta = 11;
                           else if(hiiriy > 445 && hiiriy < 505) valinta = 12;
                           else valinta = 0;
                 }
                 else valinta = 0;
                 if(kasautuminen > 20 && hiirix < 150 && hiiriy > 550) valinta = -1; //back-nappi
                 
                 //testataan irroitettiinko hiiri napin päällä
                 if(kasautuminen > 20 && valinta != 0 && hiiriprewekanappi && !hiiriekanappi) {
                           if(valinta == -1) {
                                      pois1 = true;
                                      menuvalinta = 0;
                                      if(kasautuminen > 20) kasautuminen = 20;
                           }
                           else {
                                      menuvalinta = valinta;
                                      if(menuvalinta == 100) {
                                                     pois1 = true;
                                                     kasautuminen = 20;
                                                     Mix_FadeOutMusic(2000);
                                      }
                                      else pois2 = true;
                           }
                           soitaaani(nappi2); //ääni
                 }
                 
                 //nappiäänet
                 if(hiiriekanappi && !hiiriprewekanappi && valinta != 0) soitaaani(nappi1);
                 else if(valinta != prewvalinta && valinta != 0) {
                            if(hiiriekanappi) soitaaani(nappi1);
                            else soitaaani(nappion);
                 }
                  
                 if(menuvalinta != 100) {
                                if(pelaajaninputit[SDLK_ESCAPE]) {//ESC-nappi
                                                  if(menuvalinta != 0) soitaaani(nappi2); //ääni
                                                  pois1 = true;
                                                  menuvalinta = 0;
                                                  if(kasautuminen > 20) kasautuminen = 20;
                                }
                                else if(pelaajaninputit[SDLK_RETURN] && kasautuminen > 20) { //ENTER-nappi
                                                  asetakartta("Tutorial");
                                                  soitaaani(nappi2); //ääni
                                                  pois1 = true;
                                                  menuvalinta = 100; //peliin
                                                  kasautuminen = 20;
                                                  Mix_FadeOutMusic(2000);
                                }
                 }
                 
                      //Piirretään kaikki
                 piirrakuva2(menutausta, 0, 0);
                 piirrakuva(otsikko, 400, 50);
                 //vanhat napit
                 if(kasautuminen < 20 && menuvalinta != 100) {
                                 piirrakuva(menunappinew2[0], 400 - 30 * kasautuminen, 175);
                                 //piirrakuva(menunappiscores1, 400 - 30 * kasautuminen, 250);
                                 piirrakuva(menunappisettings1, 400 - 30 * kasautuminen, 275);
                                 piirrakuva(menunappicredits1, 400 - 30 * kasautuminen, 375);
                                 piirrakuva(menunappiexit1, 400 - 30 * kasautuminen, 475);
                 }
                 //napit
                 if(menuvalinta != 100) {
                                if(kasautuminen < 20) piirrakuva(nappitakaisin[0], 75, 775 - 10 * kasautuminen);
                                else if(valinta == -1 && hiiriprewekanappi) piirrakuva(nappitakaisin[2], 75, 575);
                                else if(valinta == -1) piirrakuva(nappitakaisin[1], 75, 575);
                                else piirrakuva(nappitakaisin[0], 75, 575);
                                
                                if(kasautuminen < 20) piirrakuva(menunappitutorial1, 1000 - 30 * kasautuminen, 175);
                                else if(valinta == 100 && hiiriprewekanappi) piirrakuva(menunappitutorial2[2], 400, 175);
                                else if(valinta == 100) piirrakuva(menunappitutorial2[1], 400, 175);
                                else piirrakuva(menunappitutorial1, 400, 175);
                                
                                if(kasautuminen < 20) piirrakuva(menunappistages1, 1000 - 30 * kasautuminen, 275);
                                else if(valinta == 10 && hiiriprewekanappi) piirrakuva(menunappistages2[2], 400, 275);
                                else if(valinta == 10) piirrakuva(menunappistages2[1], 400, 275);
                                else piirrakuva(menunappistages1, 400, 275);
                                
                                if(kasautuminen < 20) piirrakuva(menunappisurvival1, 1000 - 30 * kasautuminen, 375);
                                else if(valinta == 11 && hiiriprewekanappi) piirrakuva(menunappisurvival2[2], 400, 375);
                                else if(valinta == 11) piirrakuva(menunappisurvival2[1], 400, 375);
                                else piirrakuva(menunappisurvival1, 400, 375);
                                
                                if(kasautuminen < 20) piirrakuva(menunappicustommap1, 1000 - 30 * kasautuminen, 475);
                                else if(valinta == 12 && hiiriprewekanappi) piirrakuva(menunappicustommap2[2], 400, 475);
                                else if(valinta == 12) piirrakuva(menunappicustommap2[1], 400, 475);
                                else piirrakuva(menunappicustommap1, 400, 475);
                 }
                 else {
                                piirrakuva(nappitakaisin[0], 75, 1375 - 40 * kasautuminen);
                                piirrakuva(menunappitutorial2[0], 400, 175);
                                piirrakuva(menunappistages1, 400, 275);
                                piirrakuva(menunappisurvival1, 400, 375);
                                piirrakuva(menunappicustommap1, 400, 475);
                 }
                 //loput
                 if(showfpseverywhere == 2) piirraexpluku(fps, 7);
                 piirrakuva2(menutahtain, hiirix - 1, hiiriy - 1);
                 if(kasautuminen < 20 && menuvalinta == 100) piirrakuva2(valkoinenfade, 0, 0); //fade kaiken päälle
                 
                 SDL_Flip(ruutu);
                 
                 //Lopussa tehtävät asiat
                 if(hiiriekanappi) hiiriprewekanappi = true;
                 else hiiriprewekanappi = false;
                 prewvalinta = valinta;
                 
                      if(hoidatapahtumat()) pois2 = true;
                      laskefps();
                      
    //tähän loppuu menun looppi
    }
}
